$INTERFACE UDSLX2                                             05/12/01
$REM LU
$REM  $POM1='U'
$REM  $POM2=',$$IX,-KBF)'
  $POM1='V'
  $POM2=')'
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $ADD(REAL,'\$H($MMAX)\$G($NF+1)\$S($NF+1)\$XO($NF+1)\$GO($NF+1)')
  $ADD(REAL,'\$X($NF+1)\$AZL($NA)\$AZU($NA)')
  $ADD(INTEGER,'\$IH($NF+2)\$JH($MMAX)\$IAG($NA+1)\$JAG($MA)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\BET\TEMP')
  $ADD(INTEGER,'\I\J\JP\K\L\MM')
  CALL UOD1D1
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  CALL UXVSET(NF,ZERO,$XO)
  DO $15 KA=1,NA
  IF (IEXT.EQ.0) THEN
  BET= $AZU(KA)-$AZL(KA)
  ALF=($AZU(KA)+$AZL(KA))/RPF3
  ELSE IF (IEXT.LT.0) THEN
  BET= $AZU(KA)
  ALF= BET/RPF3
  ELSE IF (IEXT.GT.0) THEN
  BET=-$AZL(KA)
  ALF=-BET/RPF3
  ENDIF
  CALL UALNG3(NF,NA,MA,KA,$XN,$AG,$IAG,$JAG,$GO,ISNA,NORMA)
  CALL UASSH3(NF,NA,MA,M,$H,$IH,$JH,$IAG,$JAG,$GO,KA,ALF)
  K=$IAG(KA)
  L=$IAG(KA+1)-K
  DO $10 J=1,L
  JP=ABS($JAG(K))
  $XO(JP)=$XO(JP)+BET*$AG(K)
  K=K+1
$10 CONTINUE
$15 CONTINUE
  IF(IDECF.NE.0.AND.IDECF.NE.1) THEN
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDSLG3',1)
  GO TO $90
  ENDIF
  INITD=MAX(ABS(INITD),1)
  MM=$IH(NF+1)-1
  IF(IDECF.NE.1) THEN
  CALL UXSPCT(NF,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
  IF (ITERM.NE.0) THEN
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
  BET=ETA2
  CALL UXSPCF(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GO,INF&
,BET,ALF)
  NDECF=NDECF+1
  IDECF=1
  ENDIF
*
*     BACK SUBSTITUTIONS
*
  CALL UXVCOP(NF,$XO,$S)
  CALL UXVSFP(NF,$PERM,$S,$GO)
  CALL UXSPCB(NF,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
  CALL UXVSBP(NF,$PERM,$S,$GO)
  CALL UXVSCL(NF,RPF3/(UXVDOT(NF,$XO,$S)-RPF3),$S,$S)
  SNORM=SQRT(UXVDOT(NF,$S,$S))
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  P=UXVDOT(NF,$S,$G)
  CALL UODLX4(NF,NA,$X,$G,$S,$GO,FF,RPF3,INF)
$90 CONTINUE
  R=ZERO
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSLX2'
  $ENDADD
  $EXIT
