$INTERFACE US0L04                                             97/12/01
  $HELP
    SWITCH FOR EXTRAPOLATION:
      1 - CONSTANT INCREASING OF THE INTERVAL
      2 - EXTRAPOLATION SPECIFIED BY THE PARAMETER MES
      3 - SUPPRESSED EXTRAPOLATION
  $CHECK(MES1,2,'1\2\3',4)
  $HELP
    SWITCH FOR TERMINATION OF LINE SEARCH:
      1 - NORMAL TERMINATION
      2 - SPECIAL TERMINATION FOR NONCONVEX FUNCTIONS
      3 - TERMINATION AFTER AT LEAST TWO STEPS
          (ASYMPTOTICALLY PERFECT LINE SEARCH)
  $CHECK(MES2,2,'1\2\3',4)
  $HELP
    UPPER BOUND FOR FUNCTION VALUE
  $CHECK(FMAX,'1.0$P 20',REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
  $CHECK(EPS1,'1.0$P-4',REAL,4)
  $HELP
    MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
  $CHECK(MRED,10,INT,4)
  CALL US0L04(NA,$AF,$AFO,$AFD,$IA,$ETA9,EPS1,RO,RP,R,FO,FP,F,PO,PP&
,FMIN,PAR,PAR1,PAR2,PAR3,RMAX,RMIN,SNORM,KA,MODE,KTERS,MES1,MES2,INITS&
,MRED)
  $ADD(INTEGER,'\$IA($NA)')
$REM  $ADD(INTEGER,'\KA\MODE\KTERS\MES1\MES2\INITS\MRED')
  $ADD(REAL,'\$AF($NA)\$AFO($NA)\$AFD($NA)')
$REM  $ADD(REAL,'\EPS1\RO\RP\R\FO\FP\F\PO\PP\FMIN\PAR\PAR1\PAR2\PAR3&
$REM  \RMAX\RMIN\SNORM')
  $ADD(INIT)
    NSXX='US0L04'
  $ENDADD
  $EXIT
