$INTERFACE US0M01                                             97/12/01
  $HELP
    FIRST TOLERANCE FOR RATIO DF/DFPRED. MARGUARDT
    PARAMETER IS INCREASED IF DF/DFPRED<EPS3
  $CHECK(EPS3,'0.25$P 0',REAL,4)
  $HELP
    SECOND TOLERANCE FOR RATIO DF/DFPRED. MARQUARDT
    PARAMETER IS DECREASED IF IT IS ACTIVE AND DF/DFPRED>EPS4
  $CHECK(EPS4,'0.75$P 0',REAL,4)
  $HELP
    LOWER BOUND FOR MARQUARDT PARAMETER EXPANSION
  $CHECK(GAM1,'2.0$P 0',REAL,4)
  $HELP
    UPPER BOUND FOR MARQUARDT PARAMETER EXPANSION
  $CHECK(GAM2,'5.0$P 1',REAL,4)
  $HELP
    MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
  $CHECK(MRED,10,INT,4)
  CALL US0M01(EPS3,EPS4,GAM1,GAM2,RO,R,FO,F,PO,PP,XDEL,SNORM,RMAX,E&
,KTERS,MRED)
$REM $ADD(REAL,'\EPS3\EPS4\GAM1\GAM2\RO\R\FO\F\PO\PP\XDEL\SNORM\RMAX\E')
$REM $ADD(INTEGER,'\KTERS\MRED')
  $ADD(INIT)
    NSXX='US0M01'
  $ENDADD
  $EXIT
