$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZADS2                                    03/10/06  +
$REM + HA                                                            +
$REM + PURPOSE:  AUTOMATICAL DIFFERENTATION (SECOND DERIVATIVES)     +
$REM +---------------------------------------------------------------+

$REM --- DELKA POLE PRO UCHOVAVANI OPERACI
$IF($DEF(NADARR))
$ELSE
  $NADARR=10000
$ENDIF

$REM --- NUTNO PRIDAT POMOCNE PROCEDURY A DEFINICE ---

$ADD(SUBROUTINES)
      INTEGER FUNCTION BPLUSG(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)+V(IARG2)
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=10
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BPLUSG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BMINUG(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)-V(IARG2)
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=20
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BMINUG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BMULTG(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)*V(IARG2)
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=30
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BMULTG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BDIVG(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)/V(IARG2)
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=40
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BDIVG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION EXPG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR, IARG1
        V(INDARR)=EXP(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=50
        ARG1(INDARR)=IARG1
        EXPG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION LOGG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=LOG(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=51
        ARG1(INDARR)=IARG1
        LOGG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION LOG10G(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=LOG10(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=54
        ARG1(INDARR)=IARG1
        LOG10G=INDARR
        INDARR=INDARR+1
      END


      INTEGER FUNCTION SING(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SIN(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=60
        ARG1(INDARR)=IARG1
        SING=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION COSG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=COS(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=61
        ARG1(INDARR)=IARG1
        COSG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ABSG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ABS(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=80
        ARG1(INDARR)=IARG1
        ABSG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION SQRTG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SQRT(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=90
        ARG1(INDARR)=IARG1
        SQRTG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BEXPG(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1, IARG2
        INTEGER NINTV
        NINTV=NINT(V(IARG2))
        IF(OPCODE(IARG2).EQ.1) THEN !IARG2 JE KONSTANTA
          IF(((ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).GT.1.0$P-14).AND.
     &        (V(IARG1).GT.0.0$P 0)) .OR.
     &        (ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).LE.1.0$P-14))
     &      THEN
              V(INDARR)=V(IARG1)**NINTV
              OPCODE(INDARR)=53
            ELSE
              WRITE(*,*) '--- BEXPG: POWER ARG ERROR! ---'
          ENDIF
        ELSE !IARG2 JE FUNKCE ANEBO MOZNA ZAKUKLENA KONSTANTA
          IF (V(IARG1).LE.0.0$P 0) THEN
            IF(ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).LE.1.0$P-14) THEN
              V(INDARR)=V(IARG1)**NINTV
            ELSE
                WRITE(*,*) '--- BEXPG: POWER ARG ERROR! ---'
            ENDIF
          ELSE
            V(INDARR)=V(IARG1)**V(IARG2)
          ENDIF
          OPCODE(INDARR)=52
        ENDIF
        VBAR(INDARR)=0.0$P 0
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BEXPG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION TANG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=TAN(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=62
        ARG1(INDARR)=IARG1
        TANG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION SINHG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SINH(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=64
        ARG1(INDARR)=IARG1
        SINHG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION COSHG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=COSH(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=65
        ARG1(INDARR)=IARG1
        COSHG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION TANHG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=TANH(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=66
        ARG1(INDARR)=IARG1
        TANHG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ASING(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ASIN(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=70
        ARG1(INDARR)=IARG1
        ASING=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ACOSG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ACOS(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=71
        ARG1(INDARR)=IARG1
        ACOSG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ATANG(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ATAN(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=72
        ARG1(INDARR)=IARG1
        ATANG=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION MKINDP(CISLO)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        REAL*8 CISLO
        V(INDARR)=CISLO
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=2
        MKINDP=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION MKCNST(CISLO)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        REAL*8 CISLO
        V(INDARR)=CISLO
        VBAR(INDARR)=0.0$P 0
        OPCODE(INDARR)=1
        MKCNST=INDARR
        INDARR=INDARR+1
      END

      REAL*8 FUNCTION SGN(CISLO)
        REAL*8 CISLO
        IF(CISLO .GT. 0.0$P 0) THEN
            SGN=1.0$P 0
          ELSEIF(CISLO .LT. 0.0$P 0) THEN
              SGN=-1.0$P 0
            ELSE
              SGN=0.0$P 0
          ENDIF
        END

      SUBROUTINE RVRSWP()
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
       INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
          INTEGER INDARR
        REAL*8 DERIV, SGN
        INTEGER I
        INTEGER NINTV
        DO 999, I=INDARR-1, 1, -1
          IF(OPCODE(I).EQ.10) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)
            VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)
          ELSEIF(OPCODE(I).EQ.20) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)
            VBAR(ARG2(I))=VBAR(ARG2(I))-VBAR(I)
          ELSEIF(OPCODE(I).EQ.30) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*V(ARG2(I))
            VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)*V(ARG1(I))
          ELSEIF(OPCODE(I).EQ.40) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG2(I))
            VBAR(ARG2(I))=VBAR(ARG2(I))-VBAR(I)*V(I)/V(ARG2(I))
          ELSEIF(OPCODE(I).EQ.50) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*V(I)
          ELSEIF(OPCODE(I).EQ.51) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG1(I))
          ELSEIF(OPCODE(I).EQ.52) THEN
            IF (V(ARG1(I)).LE.0) THEN
              NINTV=NINT(V(ARG2(I)))
              IF (ABS(NINTV-V(ARG2(I)))/MAX(1,ABS(NINTV)).LE.1.0$P-14)
     &                 THEN
                VBAR(ARG1(I))=VBAR(ARG1(I))+
     &               VBAR(I)*V(ARG2(I))*V(ARG1(I))**(NINTV-1)
              ELSE
                WRITE(*,*) '--- RVRSWP: POWER ARG ERROR! ---'
              ENDIF
            ELSE
              VBAR(ARG1(I))=VBAR(ARG1(I))+
     &             VBAR(I)*V(ARG2(I))*V(ARG1(I))**(V(ARG2(I))-1.0$P 0)
            ENDIF
            IF(V(ARG1(I)).NE.0.0$P 0) THEN
              VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)*V(I)*
     &                      LOG(ABS(V(ARG1(I))))
            ELSE
              WRITE(*,*) '--- RVRSWP: LOG ARG ERROR! ---'
            ENDIF
          ELSEIF(OPCODE(I).EQ.53) THEN
            NINTV=NINT(V(ARG2(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+
     &               VBAR(I)*NINTV*V(ARG1(I))**(NINTV-1)
          ELSEIF(OPCODE(I).EQ.54) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG1(I))/LOG(10D0)
          ELSEIF(OPCODE(I).EQ.60) THEN
            DERIV=COS(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.61) THEN
            DERIV=-SIN(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.62) THEN
            DERIV=1/(COS(V(ARG1(I))))**2
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.64) THEN
            DERIV=COSH(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.65) THEN
            DERIV=SINH(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.66) THEN
            DERIV=1/(COSH(V(ARG1(I))))**2
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.70) THEN
            DERIV=1/SQRT(1-V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.71) THEN
            DERIV=-1/SQRT(1-V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.72) THEN
            DERIV=1/(1+V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
          ELSEIF(OPCODE(I).EQ.80) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*SGN(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.90) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/(2.0$P 0*V(I))
          ELSEIF(OPCODE(I).EQ.1) THEN
            CONTINUE
          ELSEIF(OPCODE(I).EQ.2) THEN
         CONTINUE
          ENDIF
 999    CONTINUE
      END

      INTEGER FUNCTION BPLUSH(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)+V(IARG2)
        VDOT(INDARR)=VDOT(IARG2)+VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=10
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BPLUSH=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BMINUH(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)-V(IARG2)
        VDOT(INDARR)=-VDOT(IARG2)+VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=20
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BMINUH=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BMULTH(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)*V(IARG2)
        VDOT(INDARR)=V(IARG1)*VDOT(IARG2)+VDOT(IARG1)*V(IARG2)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=30
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BMULTH=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BDIVH(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1, IARG2
        V(INDARR)=V(IARG1)/V(IARG2)
        VDOT(INDARR)=(VDOT(IARG1)-VDOT(IARG2)*V(INDARR))/V(IARG2)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=40
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BDIVH=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION EXPG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=EXP(V(IARG1))
        VDOT(INDARR)=V(INDARR)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=50
        ARG1(INDARR)=IARG1
        EXPG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION LOGG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=LOG(V(IARG1))
        VDOT(INDARR)=VDOT(IARG1)/V(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=51
        ARG1(INDARR)=IARG1
        LOGG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION LOG10H(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=LOG10(V(IARG1))
        VDOT(INDARR)=VDOT(IARG1)/V(IARG1)/LOG(10D0)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=54
        ARG1(INDARR)=IARG1
        LOG10H=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION SING2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SIN(V(IARG1))
        VDOT(INDARR)=COS(V(IARG1))*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=60
        ARG1(INDARR)=IARG1
        SING2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION COSG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=COS(V(IARG1))
        VDOT(INDARR)=-SIN(V(IARG1))*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=61
        ARG1(INDARR)=IARG1
        COSG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION BEXPG2(IARG1, IARG2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1, IARG2
        INTEGER NINTV
        NINTV=NINT(V(IARG2))
        IF(OPCODE(IARG2).EQ.1) THEN !IARG2 JE KONSTANTA
          OPCODE(INDARR)=53
          IF(((ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).GT.1.0$P-14).AND.
     &        (V(IARG1).GT.0.0$P 0)) .OR.
     &        (ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).LE.1.0$P-14))
     &      THEN
              V(INDARR)=V(IARG1)**NINTV
              VDOT(INDARR)=NINTV*V(IARG1)**(NINTV-1)
            ELSE
              WRITE(*,*) '--- BEXPG2: POWER ARG ERROR! ---'
          ENDIF
        ELSE !IARG2 JE FUNKCE ANEBO MOZNA ZAKUKLENA KONSTANTA
        OPCODE(INDARR)=52
        IF (V(IARG1).LE.0.0$P 0) THEN
          IF (ABS(NINTV-V(IARG2))/MAX(1,ABS(NINTV)).LE.1.0$P-14) THEN
            V(INDARR)=V(IARG1)**NINTV
          ELSE
              WRITE(*,*) '--- BEXPG2: POWER ARG ERROR! ---'
          ENDIF
        ELSE
          V(INDARR)=V(IARG1)**V(IARG2)
        ENDIF
        IF(V(IARG1).NE.0.0$P 0) THEN
          VDOT(INDARR)=V(INDARR)*(
     &       VDOT(IARG2)*LOG(ABS(V(IARG1)))+
     &       V(IARG2)*VDOT(IARG1)/V(IARG1)
     &                         )
        ELSE
          WRITE(*,*) '--- BEXPG2: LOG ARG ERROR! ---'
        ENDIF
        IF(
     &     (ABS(-2*INT((V(IARG2))/2)+V(IARG2)-1).LT.1E-4)
     &     .AND.
     &     (V(IARG1).LT.0)
     &     ) THEN
          VDOT(INDARR)=-VDOT(INDARR)
        ENDIF
        ENDIF
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        ARG1(INDARR)=IARG1
        ARG2(INDARR)=IARG2
        BEXPG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION TANG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=TAN(V(IARG1))
        VDOT(INDARR)=1/((COS(V(IARG1)))**2)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=62
        ARG1(INDARR)=IARG1
        TANG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION SINHG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SINH(V(IARG1))
        VDOT(INDARR)=COSH(V(IARG1))*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=64
        ARG1(INDARR)=IARG1
        SINHG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION COSHG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=COSH(V(IARG1))
        VDOT(INDARR)=SINH(V(IARG1))*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=65
        ARG1(INDARR)=IARG1
        COSHG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION TANHG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=TANH(V(IARG1))
        VDOT(INDARR)=1/((COSH(V(IARG1)))**2)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=66
        ARG1(INDARR)=IARG1
        TANHG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ASING2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ASIN(V(IARG1))
        IF(V(IARG1).GE.1) WRITE(*,*) "--- ASING2: DOMAIN ERROR --- "
        VDOT(INDARR)=1/SQRT(1-V(IARG1)**2)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=70
        ARG1(INDARR)=IARG1
        ASING2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ACOSG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ACOS(V(IARG1))
        IF(V(IARG1).GE.1) WRITE(*,*) "--- ASING2: DOMAIN ERROR --- "
        VDOT(INDARR)=-1/SQRT(1-V(IARG1)**2)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=71
        ARG1(INDARR)=IARG1
        ACOSG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ATANG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=ATAN(V(IARG1))
        VDOT(INDARR)=1/(1+V(IARG1)**2)*VDOT(IARG1)
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=72
        ARG1(INDARR)=IARG1
        ATANG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION ABSG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        REAL*8 SGN
        V(INDARR)=ABS(V(IARG1))
        VDOT(INDARR)=VDOT(IARG1)*SGN(V(IARG1))
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=80
        ARG1(INDARR)=IARG1
        ABSG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION SQRTG2(IARG1)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        INTEGER IARG1
        V(INDARR)=SQRT(V(IARG1))
        VDOT(INDARR)=VDOT(IARG1)/(2.0*V(INDARR))
        VBAR(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=90
        ARG1(INDARR)=IARG1
        SQRTG2=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION MKINDPH(CISLO1,CISLO2)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        REAL*8 CISLO1, CISLO2
        V(INDARR)=CISLO1
        VBAR(INDARR)=0.0$P 0
        VDOT(INDARR)=CISLO2
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=2
        MKINDPH=INDARR
        INDARR=INDARR+1
      END

      INTEGER FUNCTION MKCNSTH(CISLO)
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        REAL*8 CISLO
        V(INDARR)=CISLO
        VBAR(INDARR)=0.0$P 0
        VDOT(INDARR)=0.0$P 0
        VBARDT(INDARR)=0.0$P 0
        OPCODE(INDARR)=1
        MKCNSTH=INDARR
        INDARR=INDARR+1
      END

      SUBROUTINE RVRSWPH()
      COMMON /AD_F2/ V, VBAR, VDOT, VBARDT, OPCODE, ARG1, ARG2, INDARR
       REAL*8 V($NADARR), VBAR($NADARR), VDOT($NADARR),VBARDT($NADARR)
        INTEGER OPCODE($NADARR), ARG1($NADARR), ARG2($NADARR)
        INTEGER INDARR
        REAL*8 DERIV,SGN
        INTEGER I, ZAP_KOEF
        INTEGER NINTV
        REAL*8 VEXPI
        DO 998, I=INDARR-1, 1, -1
          IF(OPCODE(I).EQ.10) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)
            VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)
            VBARDT(ARG2(I))=VBARDT(ARG2(I))+
     &                      VBARDT(I)
          ELSEIF(OPCODE(I).EQ.20) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)
            VBAR(ARG2(I))=VBAR(ARG2(I))-VBAR(I)
            VBARDT(ARG2(I))=VBARDT(ARG2(I))-
     &                      VBARDT(I)
          ELSEIF(OPCODE(I).EQ.30) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*V(ARG2(I))
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*V(ARG2(I))+
     &                      VBAR(I)*VDOT(ARG2(I))
            VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)*V(ARG1(I))
            VBARDT(ARG2(I))=VBARDT(ARG2(I))+
     &                      VBARDT(I)*V(ARG1(I))+
     &                      VBAR(I)*VDOT(ARG1(I))
          ELSEIF(OPCODE(I).EQ.40) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG2(I))
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      (VBARDT(I)*V(ARG2(I))-
     &                       VBAR(I)*VDOT(ARG2(I)))/
     &                       (V(ARG2(I))*V(ARG2(I)))

            VBAR(ARG2(I))=VBAR(ARG2(I))-VBAR(I)*V(I)/V(ARG2(I))
            VBARDT(ARG2(I))=VBARDT(ARG2(I))-
     &                      VBARDT(I)*V(I)/V(ARG2(I))-
     &                      VBAR(I)*VDOT(I)/V(ARG2(I))+
     &                      VBAR(I)*V(I)*VDOT(ARG2(I))/
     &                      (V(ARG2(I))*V(ARG2(I)))
          ELSEIF(OPCODE(I).EQ.50) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*V(I)
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*V(I)+
     &                      VBAR(I)*VDOT(I)
          ELSEIF(OPCODE(I).EQ.51) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG1(I))
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)/V(ARG1(I))-
     &                      VBAR(I)*VDOT(ARG1(I))/
     &                      (V(ARG1(I))*V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.52) THEN
            IF(
     &        (ABS(-2*INT((V(ARG2(I))-1.0$P 0)/2)+
     &          V(ARG2(I))-1.0$P 0-1).LT.1.0$P-4)
     &        .AND.
     &        (V(ARG1(I)).LT.0)
     &        ) THEN
              ZAP_KOEF=-1
            ELSE
              ZAP_KOEF= 1
            ENDIF
            IF (V(ARG1(I)).LE.0.0$P 0) THEN
              IF (ABS(V(ARG1(I))).LT.1.0$P-60) V(ARG1(I))=1.0$P-60
              NINTV=NINT(V(ARG2(I)))
              IF (ABS(NINTV-V(ARG2(I)))/MAX(1,ABS(NINTV)).LE.1.0$P-14)
     &             THEN
                VBAR(ARG1(I))=VBAR(ARG1(I))+
     &               VBAR(I)*V(ARG2(I))*V(ARG1(I))**(NINTV-1)
                VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &               VBARDT(I)*V(ARG2(I))*V(ARG1(I))**(NINTV-1)+
     &               VBAR(I)*VDOT(ARG2(I))*V(ARG1(I))**(NINTV-1)+
     &               VBAR(I)*V(ARG2(I))*V(ARG1(I))**(NINTV-1)*
     &               (VDOT(ARG2(I))*LOG(ABS(V(ARG1(I))))+
     &               (V(ARG2(I))-1.0$P 0)*VDOT(ARG1(I))/V(ARG1(I)))*
     &               ZAP_KOEF
              ELSE
                WRITE(*,*) '--- RVRSWPH: POWER ARG ERROR! ---'
              ENDIF
            ELSE
              VEXPI=V(ARG2(I))-1.0$P 0
              VBAR(ARG1(I))=VBAR(ARG1(I))+
     &             VBAR(I)*V(ARG2(I))*V(ARG1(I))**VEXPI
              VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &             VBARDT(I)*V(ARG2(I))*V(ARG1(I))**VEXPI+
     &             VBAR(I)*VDOT(ARG2(I))*V(ARG1(I))**VEXPI+
     &             VBAR(I)*V(ARG2(I))*V(ARG1(I))**VEXPI*
     &             (VDOT(ARG2(I))*LOG(ABS(V(ARG1(I))))+
     &             VEXPI*VDOT(ARG1(I))/V(ARG1(I)))*ZAP_KOEF
            ENDIF
            IF(V(ARG1(I)).GT.0) THEN
              VBAR(ARG2(I))=VBAR(ARG2(I))+VBAR(I)*V(I)*LOG(V(ARG1(I)))
              VBARDT(ARG2(I))=VBARDT(ARG2(I))+
     &              VBARDT(I)*V(I)*LOG(V(ARG1(I)))+
     &              VBAR(I)*VDOT(I)*LOG(V(ARG1(I)))+
     &              VBAR(I)*V(I)*VDOT(ARG1(I))/V(ARG1(I))
            ENDIF

          ELSEIF(OPCODE(I).EQ.53) THEN
            NINTV=NINT(V(ARG2(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+
     &               VBAR(I)*NINTV*V(ARG1(I))**(NINTV-1)
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &               VBARDT(I)*NINTV*V(ARG1(I))**(NINTV-1)+
     &               VBAR(I)  *NINTV*V(ARG1(I))**(NINTV-2)*
     &               VDOT(ARG1(I))*(NINTV-1)
          ELSEIF(OPCODE(I).EQ.54) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/V(ARG1(I))/LOG(10D0)
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)/V(ARG1(I))/LOG(10D0)-
     &                      VBAR(I)*VDOT(ARG1(I))/
     &                      (V(ARG1(I))*V(ARG1(I)))/LOG(10D0)
          ELSEIF(OPCODE(I).EQ.60) THEN
            DERIV=COS(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV-
     &                      VBAR(I)*SIN(V(ARG1(I)))*VDOT(ARG1(I))
          ELSEIF(OPCODE(I).EQ.61) THEN
            DERIV=-SIN(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV-
     &                      VBAR(I)*COS(V(ARG1(I)))*VDOT(ARG1(I))
          ELSEIF(OPCODE(I).EQ.62) THEN
            DERIV=1/(COS(V(ARG1(I))))**2
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV+
     &                      VBAR(I)*VDOT(ARG1(I))*2*SIN(V(ARG1(I)))*
     &                      DERIV/COS(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.64) THEN
            DERIV=COSH(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV+
     &                      VBAR(I)*VDOT(ARG1(I))*SINH(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.65) THEN
            DERIV=SINH(V(ARG1(I)))
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV+
     &                      VBAR(I)*VDOT(ARG1(I))*COSH(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.66) THEN
            DERIV=1/(COSH(V(ARG1(I))))**2
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV-
     &                      2*VBAR(I)*VDOT(ARG1(I))*SINH(V(ARG1(I)))*
     &                      DERIV/COSH(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.70) THEN
            DERIV=1/SQRT(1-V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV+
     &                      VBAR(I)*VDOT(ARG1(I))*V(ARG1(I))*
     &                      (-DERIV)**3
          ELSEIF(OPCODE(I).EQ.71) THEN
            DERIV=-1/SQRT(1-V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV-
     &                      VBAR(I)*VDOT(ARG1(I))*V(ARG1(I))*
     &                      (-DERIV)**3
          ELSEIF(OPCODE(I).EQ.72) THEN
            DERIV=1/(1+V(ARG1(I))**2)
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*DERIV
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*DERIV-
     &                      2*VBAR(I)*VDOT(ARG1(I))*V(ARG1(I))*
     &                      DERIV**2
          ELSEIF(OPCODE(I).EQ.80) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)*SGN(V(ARG1(I)))
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)*SGN(V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.90) THEN
            VBAR(ARG1(I))=VBAR(ARG1(I))+VBAR(I)/(2.0*V(I))
            VBARDT(ARG1(I))=VBARDT(ARG1(I))+
     &                      VBARDT(I)/(2.0*V(I))-
     &                     VBAR(I)*VDOT(ARG1(I))/(4.0*V(I)*V(ARG1(I)))
          ELSEIF(OPCODE(I).EQ.2) THEN
            CONTINUE
          ELSEIF(OPCODE(I).EQ.1) THEN
            CONTINUE
          ELSE
            WRITE(*,*) '--- NEDEFINOVANA OPERACE! ---'
          ENDIF
 998    CONTINUE
      END
$ENDADD

