$INTERFACE U2FSL1                                             97/12/01
$REM TU
  $PTR='ICG'
  $CNR='JCG'
  $AU='CG'
  $N='NF'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD\KBFPOM')
$REM  $GRADIS='NO'
$REM  $IF(GRAPH='YES') $GRADIS='YES'
$REM  $IF(DISPLAY='YES') $GRADIS='YES'
  $HELP
    LOWER BOUND FOR CONSTRAINT VIOLATION
  $CHECK(TOLC,'1.0$P-6',REAL,3)
  $TYPE='L'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='M'
  $NUMBER=3
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
  $ENDIF
  $HELP
    TOLERANCE FOR DESCENT DIRECTION
  $CHECK(EPS0,'1.0$P-8',REAL,4)
  ISNC=0
  MCL=M
  HDEL=XMAX
  KBFPOM=KBF
  $NF='$MCOLS'
$REM  $ADD(SINIT)
$REM    $SUBST('UKLINI')
$REM  $ENDADD
  CALL UXVINS(NF,0,$LENR)
  IF (KBF.LE.0) CALL UXVINS(NF,0,$IX)
  CALL UXVINS(MCOLS-NF,0,$IX(NF+1))
  CALL UXVSET(MCOLS-NF,ZERO,$GF(NF+1))
  CALL UXVSET(MCOLS-NF,ZERO,$G(NF+1))
$REM  $IF(GRADIS='YES')
    $ICS=IC
    $CLS=CL
    $CUS=CU
    $IF(KBC>0)
      $IC='ICC'
      CALL UXVICP(NC,$ICS,$IC)
      $ADD(INTEGER,'\$ICS($MROWS)')
      $CL='CCL'
      CALL UXVCOP(NC,$CLS,$CL)
      $ADD(REAL,'\$CLS($MROWS)')
    $ENDIF
    $IF(KBC>1)
      $CU='CCU'
      CALL UXVCOP(NC,$CUS,$CU)
      $ADD(REAL,'\$CUS($MROWS)')
    $ENDIF
$REM  $ENDIF
  $KD=1
  KD=1
  JOUT=1
  CALL UXVINS(MMAX-$IH(NF+1)+1,0,$JH($IH(NF+1)))
  $SUBST('UO0FU1')
  $IF(MODEL='FQ')
*
*     -----------------
*     MODEL DESCRIPTION
*     -----------------
*
    $HELP
      LOWER BOUND FOR FUNCTION VALUE
    $CHECK(FMIN,'-$ETA9',REAL,3)
    $GQ='GQ'
    $ADD(REAL,'\$GQ($NF)\FQ')
    FQ=FF
    CALL UXVCOP(NF,$GF,$GQ)
    $IF($DEF(IEXT))
      $IF(IEXT=0)
        $G=GF
      $ENDIF
    $ELSE
      $G=GF
    $ENDIF
    CALL UF1FQ2(NF,$IH(NF+1)-1,$X,$GQ,$G,$HF,$IH,$JH,FQ,F)
*
*     ------------------------
*     END OF MODEL DESCRIPTION
*     ------------------------
*
  $ELSE
    $SUBST('UZMODL')
  $ENDIF
  MFP=1
  LCS=0
  JOUT=1
$SUBST('UKLINM')
  $SUBST('UKSGLM')
  ITERM=ITERL
  IF (ITERM.GE.0) THEN
  $SUBST('UKLNF4')
  CALL UYCMAX(NC,$CF,$ICS,$CLS,$CUS,CMAX)
  IF (CMAX.GE.TOLC) THEN
  CALL UOERR1('U1FSQ1',89)
  ITERM=-89
  ENDIF
  ENDIF
  IF (ITERM.GE.0) THEN
  ITERM=0
  ELSE
  GO TO $90
  ENDIF
  CALL UYSET2
  $SUBST('UZLIND')
  LINP=M
  MFP=2
  ITERQ=0
  $IF(KDF=1) $SUBST('UYPTSH')
*
*     -----------------------------------
*     RECURSIVE PROGRAMMING NEWTON METHOD
*     TEMPLATE : U2FSL1
*     -----------------------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
$L=$10 ; $LABEL
  $KD=2
  $IF(MODEL='FQ')
*
*     -----------------
*     MODEL DESCRIPTION
*     -----------------
*
    $IF($DEF(IEXT))
      $IF(IEXT=0)
        $G=GF
        $H=HF
      $ENDIF
    $ELSE
      $G=GF
      $H=HF
    $ENDIF
    CALL UF2FQ2(NF,$IH(NF+1)-1,$X,$GQ,$G,$HF,$H,$IH,$JH,FQ,F)
*
*     ------------------------
*     END OF MODEL DESCRIPTION
*     ------------------------
*
  $ELSE
    $SUBST('UZMODL')
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTSLM')
  $SUBST('UYTSSG')
  $IF(NORMF=0) $GN=G
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $90
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GOTO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=2)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTSUH')
  $G='G'
  KBF=0
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDSSQ$(NUMBER)
*     -----------------------
*
  $SUBST('UDSSQ$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
$REM  XMAX=HDEL
  KBF=KBFPOM
  $G='GF'
  $SN='S'
  $SUBST('UD1T$(TYPE)1')
  $SN='SN'
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  IF(NIT.EQ.LIT+1) KIT=NIT
  $SUBST('UYTRUS')
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  KBF=0
  $SUBST('UYTSUD')
  $SUBST('UYTRUD')
  KBF=KBFPOM
  GOTO $30
$L=$ 90 ; $LABEL
  XMAX=HDEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
$REM  $IF(GRADIS='YES')
  $IF(KBC>0) $IC=ICS
  $IF(KBC>0) $CL=CLS
  $IF(KBC>1) $CU=CUS
$REM  $ENDIF
  $SUBST('UKLNF4')
  $SUBST('UYCMAX')
  FF=F
  $SUBST('UO1FU2')
  M=MCL
  $ADD(INIT)
    NXFU='U2FSL1'
  $ENDADD
  $EXIT
